USE [TP_DATABASE_NAME]
GO
/****** Object:  StoredProcedure [dbo].[archive_garbageCollectTaskPersistence]    Script Date: 12/05/2011 14:18:58 ******/
SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO
CREATE PROCEDURE [dbo].[archive_garbageCollectTaskPersistence]
@ime_id VARCHAR(50),
@chunk_rec_count int =500
AS
	DECLARE @gcTaskId VARCHAR(255);
	DECLARE @counter int;
	DECLARE @transactionsCount int;
	declare @Error int

	DECLARE gcTasksCoursor CURSOR LOCAL FOR
			SELECT tasksessionid 
		FROM archive_tasksession12_5 
		WHERE environmentid = @ime_id 
			AND (
				
					(archive_tasksession12_5.state = 4) --  pending
                     OR (archive_tasksession12_5.state = 2048) --  primary pending state
                     OR (archive_tasksession12_5.state = 8192) --  secondary pending_state
				);

BEGIN
	set @counter = 0;
	OPEN gcTasksCoursor;
	begin transaction;
	WHILE 1 = 1 
	BEGIN
		FETCH NEXT FROM gcTasksCoursor INTO @gcTaskId;
		IF @@FETCH_STATUS <> 0 BREAK;  -- exit loop if condition is true
		set @counter = @counter +1;
		EXEC archive_garbageCollectByTaskId @gcTaskId;
	    set @Error = @@ERROR
	    if @Error <> 0 --if error is raised
  		  goto LogError

		IF (@counter = @chunk_rec_count)
		BEGIN
			commit;
			set @counter = 0;
			begin transaction;
		END
	END

	if (@counter > 0)
		commit;
	set @transactionsCount = @@trancount;
	if (@transactionsCount >0)
		commit;
	CLOSE gcTasksCoursor;
	DEALLOCATE gcTasksCoursor;
	goto ProcEnd
LogError:
	set @transactionsCount = @@trancount;
	if (@transactionsCount >0)
		rollback transaction

ProcEnd:


END --archive_garbageCollectTaskPersistence